LibreOffice: XDocumentDigitalSignatures Interface Reference

LibreOffice LibreOffice 26.8 SDK API Reference

Loading...
Searching...
No Matches
XDocumentDigitalSignatures Interface Reference

Interface for signing and verifying digital signatures in office documents. More...

`import "XDocumentDigitalSignatures.idl";`

Inheritance diagram for XDocumentDigitalSignatures:

## Public Member Functions
boolean | signSignatureLine ([in] ::com::sun::star::embed::XStorage xStorage, [in] ::com::sun::star::io::XStream xSignStream, [in] string signatureLineId, [in] ::com::sun::star::security::XCertificate xCertificate, [in] ::com::sun::star::graphic::XGraphic xValidGraphic, [in] ::com::sun::star::graphic::XGraphic xInvalidGraphic, [in] string comment)
| Signs the content of the document including text and pictures using the given XCertificate.
sequence< com::sun::star::security::DocumentSignatureInformation > | verifyDocumentContentSignatures ([in] ::com::sun::star::embed::XStorage xStorage, [in] ::com::sun::star::io::XInputStream xSignInStream)
| checks for digital signatures and their status.
void | showDocumentContentSignatures ([in] ::com::sun::star::embed::XStorage xStorage, [in] ::com::sun::star::io::XInputStream xSignInStream)
| shows the digital signatures of the document content
string | getDocumentContentSignatureDefaultStreamName ()
| allows to get the default stream name for storing of the signature of the document content.
sequence< com::sun::star::security::DocumentSignatureInformation > | verifyScriptingContentSignatures ([in] ::com::sun::star::embed::XStorage xStorage, [in] ::com::sun::star::io::XInputStream xSignInStream)
| checks for digital signatures and their status.
void | showScriptingContentSignatures ([in] ::com::sun::star::embed::XStorage xStorage, [in] ::com::sun::star::io::XInputStream xSignInStream)
| shows the digital signatures of the scripting content
string | getScriptingContentSignatureDefaultStreamName ()
| allows to get the default stream name for storing of the signature of the scripting content.
void | showCertificate ([in] com::sun::star::security::XCertificate Certificate)
void | manageTrustedSources ()
| manages trusted sources (Authors and paths )
boolean | isAuthorTrusted ([in] com::sun::star::security::XCertificate Author)
boolean | isLocationTrusted ([in] string Location)
void | addAuthorToTrustedSources ([in] com::sun::star::security::XCertificate Author)
void | addLocationToTrustedSources ([in] string Location)
com::sun::star::security::XCertificate | chooseCertificate ([out] string Description)
| This method shows the CertificateChooser dialog, used by document and PDF signing Shows only private certificates.
com::sun::star::security::XCertificate | chooseSigningCertificate ([out] string Description)
| This is an alias for 'chooseCertificate', shows the CertificateChooser dialog with private certificates.
com::sun::star::security::XCertificate | selectSigningCertificate ([out] string Description)
| This shows the certificate selection dialog and allows to only select the certificate without actually signing the document.
com::sun::star::security::XCertificate | selectSigningCertificateWithType ([in] CertificateKind certificateKind, [out] string Description)
| This shows the certificate selection dialog and allows to only select the certificate without actually signing the document.
sequence< com::sun::star::security::XCertificate > | chooseEncryptionCertificate ([in] CertificateKind certificateKind)
| This method shows the CertificateChooser dialog with all certificates, private and other people's.
com::sun::star::security::XCertificate | chooseCertificateWithProps ([out] sequence<::com::sun::star::beans::PropertyValue > Properties)
| This method shows the CertificateChooser dialog, used by document and PDF signing Shows only private certificates and returns usage string in addition to description.
boolean | signDocumentWithCertificate ([in] ::com::sun::star::security::XCertificate xCertificate, [in] ::com::sun::star::embed::XStorage xStorage, [in] ::com::sun::star::io::XStream xStream)
| Signs the content of the document with the provided certificate.
void | setParentWindow ([in] ::com::sun::star::awt::XWindow xParentWindow)
| Set parent window to use when showing dialogs.
boolean | signScriptingContentWithCertificate ([in] ::com::sun::star::security::XCertificate xCertificate, [in] ::com::sun::star::embed::XStorage xStorage, [in] ::com::sun::star::io::XStream xStream)
| signs the content of the Scripting including macros and basic dialogs with the provided certificate.
boolean | trustUntrustedCertificate ([in] ::com::sun::star::security::XCertificate xCertificate)
| queries the user if they want to trust an untrusted certificate.
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object.
void | acquire ()
| increases the reference counter by one.
void | release ()
| decreases the reference counter by one.

## Detailed Description

Interface for signing and verifying digital signatures in office documents.

This interface can be used to digitally sign different content in an office document. It can also be used to verify digital signatures.

## Member Function Documentation

## ◆ addAuthorToTrustedSources()

void addAuthorToTrustedSources | ( | [in] com::sun::star::security::XCertificate | Author | ) |

## ◆ addLocationToTrustedSources()

void addLocationToTrustedSources | ( | [in] string | Location | ) |

## ◆ chooseCertificate()

com::sun::star::security::XCertificate chooseCertificate | ( | [out] string | Description | ) |

This method shows the CertificateChooser dialog, used by document and PDF signing Shows only private certificates.

Since
  LibreOffice 5.3

## ◆ chooseCertificateWithProps()

com::sun::star::security::XCertificate chooseCertificateWithProps | ( | [out] sequence<::com::sun::star::beans::PropertyValue > | Properties | ) |

This method shows the CertificateChooser dialog, used by document and PDF signing Shows only private certificates and returns usage string in addition to description.

Since
  LibreOffice 6.0

## ◆ chooseEncryptionCertificate()

sequence< com::sun::star::security::XCertificate > chooseEncryptionCertificate | ( | [in] CertificateKind | certificateKind | ) |

This method shows the CertificateChooser dialog with all certificates, private and other people's.

Useful when choosing certificate/key for encryption.

Parameters

  certificateKind | com::sun::star::security::CertificateKind ENUM to choose only from certificates of a certain type. CertificateKind_NONE lists all types of certificates for choosing.

Since
  LibreOffice 25.2

## ◆ chooseSigningCertificate()

com::sun::star::security::XCertificate chooseSigningCertificate | ( | [out] string | Description | ) |

This is an alias for 'chooseCertificate', shows the CertificateChooser dialog with private certificates.

Since
  LibreOffice 6.0

## ◆ getDocumentContentSignatureDefaultStreamName()

string getDocumentContentSignatureDefaultStreamName | ( |  | ) |

allows to get the default stream name for storing of the signature of the document content.

## ◆ getScriptingContentSignatureDefaultStreamName()

string getScriptingContentSignatureDefaultStreamName | ( |  | ) |

allows to get the default stream name for storing of the signature of the scripting content.

## ◆ isAuthorTrusted()

boolean isAuthorTrusted | ( | [in] com::sun::star::security::XCertificate | Author | ) |

## ◆ isLocationTrusted()

boolean isLocationTrusted | ( | [in] string | Location | ) |

## ◆ manageTrustedSources()

void manageTrustedSources | ( |  | ) |

manages trusted sources (Authors and paths )

## ◆ selectSigningCertificate()

com::sun::star::security::XCertificate selectSigningCertificate | ( | [out] string | Description | ) |

This shows the certificate selection dialog and allows to only select the certificate without actually signing the document.

Since
  LibreOffice 6.1

## ◆ selectSigningCertificateWithType()

com::sun::star::security::XCertificate selectSigningCertificateWithType | ( | [in] CertificateKind | certificateKind,
|  | [out] string | Description )

This shows the certificate selection dialog and allows to only select the certificate without actually signing the document.

Only certificates of the given type will be shown.

Parameters

  certificateKind | com::sun::star::security::CertificateKind ENUM to choose only from certificates of a certain type. CertificateKind_NONE lists all types of certificates for choosing.

Since
  LibreOffice 6.2

## ◆ setParentWindow()

void setParentWindow | ( | [in] ::com::sun::star::awt::XWindow | xParentWindow | ) |

Set parent window to use when showing dialogs.

Since
  LibreOffice 6.3

## ◆ showCertificate()

void showCertificate | ( | [in] com::sun::star::security::XCertificate | Certificate | ) |

## ◆ showDocumentContentSignatures()

void showDocumentContentSignatures | ( | [in] ::com::sun::star::embed::XStorage | xStorage,
|  | [in] ::com::sun::star::io::XInputStream | xSignInStream )

shows the digital signatures of the document content

## ◆ showScriptingContentSignatures()

void showScriptingContentSignatures | ( | [in] ::com::sun::star::embed::XStorage | xStorage,
|  | [in] ::com::sun::star::io::XInputStream | xSignInStream )

shows the digital signatures of the scripting content

## ◆ signDocumentWithCertificate()

boolean signDocumentWithCertificate | ( | [in] ::com::sun::star::security::XCertificate | xCertificate,
|  | [in] ::com::sun::star::embed::XStorage | xStorage,
|  | [in] ::com::sun::star::io::XStream | xStream )

Signs the content of the document with the provided certificate.

Since
  LibreOffice 6.2

## ◆ signScriptingContentWithCertificate()

boolean signScriptingContentWithCertificate | ( | [in] ::com::sun::star::security::XCertificate | xCertificate,
|  | [in] ::com::sun::star::embed::XStorage | xStorage,
|  | [in] ::com::sun::star::io::XStream | xStream )

signs the content of the Scripting including macros and basic dialogs with the provided certificate.

The rest of document content will not be signed.

Since
  LibreOffice 7.0

## ◆ signSignatureLine()

boolean signSignatureLine | ( | [in] ::com::sun::star::embed::XStorage | xStorage,
|  | [in] ::com::sun::star::io::XStream | xSignStream,
|  | [in] string | signatureLineId,
|  | [in] ::com::sun::star::security::XCertificate | xCertificate,
|  | [in] ::com::sun::star::graphic::XGraphic | xValidGraphic,
|  | [in] ::com::sun::star::graphic::XGraphic | xInvalidGraphic,
|  | [in] string | comment )

Signs the content of the document including text and pictures using the given XCertificate.

Also adds the given Signature Line Id and the signed and unsigned graphics to the signature.

Macros will not be signed.

Since
  LibreOffice 6.1

## ◆ trustUntrustedCertificate()

boolean trustUntrustedCertificate | ( | [in] ::com::sun::star::security::XCertificate | xCertificate | ) |

queries the user if they want to trust an untrusted certificate.

Since
  LibreOffice 24.8

## ◆ verifyDocumentContentSignatures()

sequence< com::sun::star::security::DocumentSignatureInformation > verifyDocumentContentSignatures | ( | [in] ::com::sun::star::embed::XStorage | xStorage,
|  | [in] ::com::sun::star::io::XInputStream | xSignInStream )

checks for digital signatures and their status.

Only document content will be checked.

## ◆ verifyScriptingContentSignatures()

sequence< com::sun::star::security::DocumentSignatureInformation > verifyScriptingContentSignatures | ( | [in] ::com::sun::star::embed::XStorage | xStorage,
|  | [in] ::com::sun::star::io::XInputStream | xSignInStream )

checks for digital signatures and their status.

Only Scripting content will be checked.

The documentation for this interface was generated from the following file:

- com/sun/star/security/XDocumentDigitalSignatures.idl